﻿Imports System.Drawing.Color
Imports System.Reflection.MethodBase
Imports ErrorLog
Imports ErrorLog.LogStates
Imports System.ComponentModel.Design
Imports System.ComponentModel

Public Class ucAbout
    Private sModule As String = "ucAbout"
    Public Event ErrorRaised(oDetail As ErrorDetail)

    Public Property LogoName As System.Drawing.Image
    Public Property LogoImage As System.Drawing.Image

    <Editor(GetType(MultilineStringEditor), GetType(System.Drawing.Design.UITypeEditor))>
    Public Property Description As String
    Public Property Website As String
    Public Property LicenceURL As String
    Public Property DocumentationURL As String

    Public Enum Licencing
        Licenced
        Shareware
        Donationware
    End Enum

    Private oLicencingModel As Licencing
    Public Property LicencingModel As Licencing
        Get
            Return oLicencingModel
        End Get
        Set(value As Licencing)
            oLicencingModel = value
            Select Case oLicencingModel
                Case Licencing.Licenced
                    tabLicensing.SelectedTab = tpLicenced
                    tpLicenced.Visible = True
                    tpDonation.Visible = False
                    tabLicensing.TabPages.Remove(tpDonation)
                Case Licencing.Donationware
                    tabLicensing.SelectedTab = tpDonation
                    tpLicenced.Visible = False
                    tpLicenced.Hide()
                    tpDonation.Visible = True
                    tabLicensing.TabPages.Remove(tpLicenced)
            End Select
        End Set
    End Property

    Public Property Copyright As String
        Get
            Return lblCopyright.Text
        End Get
        Set(value As String)
            lblCopyright.Text = value
        End Set
    End Property

    Public Property DonationText As String
        Get
            Return lblDonation.Text
        End Get
        Set(value As String)
            lblDonation.Text = value
        End Set
    End Property

    Public Property Version As String
        Get
            Return lblVersion.Text
        End Get
        Set(value As String)
            lblVersion.Text = value
        End Set
    End Property

    Public Property VersionDate As String
        Get
            Return lblVersionDate.Text
        End Get
        Set(value As String)
            lblVersionDate.Text = value
        End Set
    End Property

    Private Sub cmdOK_Click(sender As Object, e As EventArgs) Handles cmdOK.Click
        Me.ParentForm.Close()
    End Sub

    Private Sub ucAbout_Load(sender As Object, e As EventArgs) Handles Me.Load
        Try
            picLogoName.Image = LogoName
            picLogo.Image = LogoImage
            lblDescription.Text = Description
            lblVersion.Text = Version
            lblVersionDate.Text = VersionDate
            tpLicenced.BackColor = Me.BackColor
            tpDonation.BackColor = Me.BackColor
            tpLicenced.Text = ""
            tpLicenced.Text = ""

        Catch ex As Exception
            RaiseEvent ErrorRaised(New ErrorDetail(LSError, ex.Message, "", sModule & "." & GetCurrentMethod().Name, ex))
        End Try
    End Sub

    Private Sub lblWebsite_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles lblWebsite.LinkClicked
        LoadWebPage(Website)
    End Sub

    Private Sub lblLicence_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles lblLicence.LinkClicked
        LoadWebPage(LicenceURL)
    End Sub

    Private Sub lblDocumentation_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles lblDocumentation.LinkClicked
        LoadWebPage(DocumentationURL)
    End Sub

    Private Sub cmdDonate_Click(sender As Object, e As EventArgs) Handles cmdDonate.Click
        LoadWebPage("https://www.paypal.com/donate/?hosted_button_id=FJCUQVE8YJDDJ")
    End Sub

    Private Sub LoadWebPage(sPageURL)
        Try
            If sPageURL Is Nothing Then Exit Sub
            If sPageURL.ToLower.StartsWith("http") Then
                System.Diagnostics.Process.Start(sPageURL)
            Else
                System.Diagnostics.Process.Start("http://" & sPageURL)
            End If
        Catch ex As Exception
            RaiseEvent ErrorRaised(New ErrorDetail(LSError, ex.Message & ": " & sPageURL, "", sModule & "." & GetCurrentMethod().Name, ex))
        End Try
    End Sub

End Class
