﻿Imports System.Drawing.Color
Imports System.Reflection.MethodBase
Imports ErrorLog
Imports ErrorLog.LogStates
Imports System.Threading
Imports System.Windows.Forms

Public Module modFormUtils
    Private sModule As String = "Module"
    Public Event ErrorRaised(oDetail As ErrorDetail)

    Private bAutoClosed As Boolean

    Private Sub CloseMsgBoxDelay(ByVal iTimeoutMS As Object)
        ' Automatically close message box after specified delay
        System.Threading.Thread.Sleep(CInt(iTimeoutMS))
        SendKeys.SendWait("~")
        bAutoClosed = True
    End Sub

    Public Function MsgBoxDelayClose(sPrompt As String, ByVal iTimeoutMS As Integer,
                                     Optional oDelayedResult As MsgBoxResult = MsgBoxResult.Ok,
                                     Optional oButtons As MsgBoxStyle = MsgBoxStyle.ApplicationModal,
                                     Optional sTitle As String = Nothing) As MsgBoxResult

        Try
            Dim t As Thread
            If iTimeoutMS > 0 Then
                bAutoClosed = False
                t = New Thread(AddressOf CloseMsgBoxDelay)
                t.Start(iTimeoutMS)

                MsgBoxDelayClose = MsgBox(sPrompt, oButtons, sTitle)
                If bAutoClosed Then
                    MsgBoxDelayClose = oDelayedResult
                Else
                    t.Abort()
                End If
            Else
                MsgBoxDelayClose = MsgBox(sPrompt, oButtons, sTitle)
            End If

        Catch ex As Exception
            Throw New Exception(sModule & "." & GetCurrentMethod().Name & ":" & ex.Message, ex)
        End Try
    End Function

End Module
