﻿Imports System.Reflection.MethodBase
Imports ErrorLog
Imports ErrorLog.LogStates
Imports System.IO

Public Module modProcess

    Private sModule As String = "modProcess"
    'Public Event ErrorRaised(oDetail As ErrorDetail)

    Public Function RunProcess(sExecutable As String, sParameters As String, Optional sDirectory As String = "") As ProcessOutput
        ' Execute pricess in hidden window and capture output
        Try
            Dim oOutput As New ProcessOutput
            Dim pProcess As New System.Diagnostics.Process()            ' Create process
            pProcess.StartInfo.FileName = sExecutable                   ' Set executable and parameters
            pProcess.StartInfo.Arguments = sParameters
            pProcess.StartInfo.UseShellExecute = False                  ' Control execution visibility
            pProcess.StartInfo.CreateNoWindow = True
            pProcess.StartInfo.RedirectStandardOutput = True            ' Set outputs of program to be written to process output stream
            pProcess.StartInfo.RedirectStandardError = True
            pProcess.StartInfo.RedirectStandardInput = True
            If sDirectory <> "" Then pProcess.StartInfo.WorkingDirectory = sDirectory
            pProcess.Start()                                            ' Start the process
            pProcess.StandardInput.WriteLine("")                        ' Required to complete processing, equivalent of pressing return to continue
            pProcess.WaitForExit()                                      ' Wait for process to finish
            oOutput.StdOutput = pProcess.StandardOutput.ReadToEnd()     ' Read outputs
            oOutput.StdError = pProcess.StandardError.ReadToEnd
            Return oOutput
        Catch ex As Exception
            Throw New Exception(sModule & "." & GetCurrentMethod().Name & ":" & ex.Message, ex)
        End Try
    End Function

    Public Function ExifToolQuery(sFilename As String) As Collection
        ' Run Exiftool on nominated file and return output as collection of string values
        ' We have to write to a file, read and then delete it, as writing output to console doesn't work
        Try
            Dim sCmd, sExecutable, sResult, sOutFile, sValues As String
            sExecutable = "C:\Utils\exiftool.exe"
            sCmd = "-t -d %d/%m/%Y -w! c:\temp\%f.txt "
            Dim oFile As New FileInfo(sFilename)
            sOutFile = "C:\Temp\" & oFile.Name.Replace(oFile.Extension, ".txt")
            Dim oOutput As ProcessOutput = RunProcess(sExecutable, sCmd & """" & sFilename & """")
            sResult = oOutput.StdOutput
            If sResult.Contains("1 output files created") Then
                sValues = File.ReadAllText(sOutFile)
                Dim oCollection As New Collection
                Dim sLines() As String = sValues.Split(vbCr)
                For Each sLine As String In sLines
                    Dim sParts() As String = sLine.Split(vbTab)
                    If Not oCollection.Contains(sParts(0).Trim) And sParts.Length > 1 Then oCollection.Add(sParts(1).Trim, sParts(0).Trim)
                Next
                File.Delete(sOutFile)
                Return oCollection
            End If

        Catch ex As Exception
            Throw New Exception(sModule & "." & GetCurrentMethod().Name & ":" & ex.Message, ex)
        End Try
    End Function

    Public Class ProcessOutput
        Public Result As Integer
        Public StdOutput As String
        Public StdError As String
    End Class
End Module

